//
// Copyright (c) 2016, MindFusion LLC - Bulgaria.
//

using System;
using System.Drawing;
using System.Windows.Forms;


namespace MindFusion.Scheduling.WinForms.Samples.CS.ResourceTable
{
	/// <summary>
	/// Summary description for MainForm.
	/// </summary>
	public partial class MainForm : Form
	{
		/// <summary>
		/// Initializes a new instance of the MainForm class.
		/// </summary>
		public MainForm()
		{
			InitializeComponent();

			_appPath = System.IO.Path.GetDirectoryName(Application.ExecutablePath);

			_lbInfo.DocumentText = Properties.Resources.Info;
			_lbInfo.DocumentCompleted += new WebBrowserDocumentCompletedEventHandler(OnDocumentCompleted);

			// Create the appointments
			Appointment app;

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 27);
			app.EndTime = new DateTime(2006, 3, 28);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdMike"]);
			app.HeaderText = "21965 Carbon Mesa Rd (1)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 27);
			app.EndTime = new DateTime(2006, 3, 28);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdMike"]);
			app.HeaderText = "777 Ocampo Dr (1)";
			app.Priority = -1;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 27);
			app.EndTime = new DateTime(2006, 3, 28);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdMike"]);
			app.HeaderText = "401 Almar Ave (1)";
			app.Priority = -2;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 27);
			app.EndTime = new DateTime(2006, 3, 28);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdMike"]);
			app.HeaderText = "16680 Charmel Ln (1)";
			app.Priority = -3;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 27);
			app.EndTime = new DateTime(2006, 3, 28);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdMike"]);
			app.HeaderText = "10785 Queensland St (1)";
			app.Priority = -4;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 27);
			app.EndTime = new DateTime(2006, 3, 28);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdMike"]);
			app.HeaderText = "1237 25th St (1)";
			app.Priority = -5;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 27);
			app.EndTime = new DateTime(2006, 3, 28);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdMike"]);
			app.HeaderText = "3569 Veteran Ave (1)";
			app.Priority = -6;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 28);
			app.EndTime = new DateTime(2006, 3, 29);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdMike"]);
			app.HeaderText = "242 Aderno Way (1)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 27);
			app.EndTime = new DateTime(2006, 3, 28);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdGreg"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdScott"]);
			app.HeaderText = "8359 Hollywood Blvd (17)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 27);
			app.EndTime = new DateTime(2006, 3, 28);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdGreg"]);
			app.HeaderText = "2788 Monte Mar Ter (14)";
			app.Priority = -1;
			_calendar.Schedule.Items.Add(app);

			// Dummy item to expand the rows of certain resources
			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 27);
			app.EndTime = new DateTime(2006, 3, 28);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdGreg"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdTom"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdMando"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdAlfredo"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdChuck"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdJJ"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdLuis"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdScott"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdRamon"]);
			app.HeaderText = "";
			app.Priority = -100;
			_calendar.Schedule.Items.Add(app);

			// Dummy item #2
			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 27);
			app.EndTime = new DateTime(2006, 3, 28);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdTom"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdAlfredo"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdChuck"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdJJ"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdLuis"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdRamon"]);
			app.HeaderText = "";
			app.Priority = -100;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 29);
			app.EndTime = new DateTime(2006, 3, 30);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdGreg"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdChuck"]);
			app.HeaderText = "11301 Wilshire Blvd. (43)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 27);
			app.EndTime = new DateTime(2006, 3, 28);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdTom"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdScott"]);
			app.HeaderText = "6200 San Fernando Rd (?)";
			app.Priority = -1;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 29);
			app.EndTime = new DateTime(2006, 3, 30);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdTom"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdJJ"]);
			app.HeaderText = "247 W San Bernardino Rd (17)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 27);
			app.EndTime = new DateTime(2006, 3, 28);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdMando"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdJJ"]);
			app.HeaderText = "1156 Napoli Dr (6)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 27);
			app.EndTime = new DateTime(2006, 3, 28);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdMando"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdLuis"]);
			app.HeaderText = "1801 San Vicente Blvd (16)";
			app.Priority = -1;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 29);
			app.EndTime = new DateTime(2006, 3, 30);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdMando"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdScott"]);
			app.HeaderText = "245 Maple Dr (7)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 30);
			app.EndTime = new DateTime(2006, 3, 31);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdMando"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdJJ"]);
			app.HeaderText = "162 Acari Dr (16)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 27);
			app.EndTime = new DateTime(2006, 3, 28);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdAlfredo"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdChuck"]);
			app.HeaderText = "427 Mesa Lila Rd (21)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2006, 3, 30);
			app.EndTime = new DateTime(2006, 3, 31);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdChuck"]);
			app.Contacts.Add(_calendar.Schedule.Contacts["IdJJ"]);
			app.HeaderText = "2201 Beverly Dr (41)";
			app.Priority = -1;
			_calendar.Schedule.Items.Add(app);
		}

		private void OnDocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
		{
			if (_lbInfo.Document != null)
			{
				_lbInfo.Document.Click += Document_Click;
				_lbInfo.Document.Body.Style = "font-family: Verdana, Arial, Helvetica, sans-serif; " +
					"font-size: 7.5pt; margin: 2pt; padding: 0pt; background-color: #ffffee; cursor: default;";
			}
		}

		/// <summary>
		/// Handles the Web browser document's Click event.
		/// </summary>
		private void Document_Click(object sender, HtmlElementEventArgs e)
		{
			e.ReturnValue = true;

			HtmlElement pointed = _lbInfo.Document.GetElementFromPoint(e.ClientMousePosition);
			if (pointed == null)
				return;

			if (pointed.TagName.ToLower() == "a")
			{
				string href = pointed.GetAttribute("href").ToLower();
				if (href.StartsWith("help:"))
				{
					string topic = href.Substring(5);
					string helpFile = ResolveHelpPath(_appPath);

					if (System.IO.File.Exists(helpFile))
					{
						Help.ShowHelp(this, helpFile, HelpNavigator.Topic, topic);

						// Prevent link follow
						e.ReturnValue = false;
					}
				}
			}
		}

		private static string ResolveHelpPath(string baseDir)
		{
			string[] helpFiles = new string[]
			{
				"MindFusion.Scheduling.chm",
				"MindFusion WinForms.chm"
			};

			System.IO.DirectoryInfo dirInfo = new System.IO.DirectoryInfo(baseDir);
			int i = 0;
			while (dirInfo != null)
			{
				string helpFile = System.IO.Path.Combine(dirInfo.FullName, helpFiles[i]);
				if (System.IO.File.Exists(helpFile))
					return helpFile;

				i++;
				if (i == helpFiles.Length)
				{
					i = 0;
					dirInfo = dirInfo.Parent;
				}
			}

			return string.Empty;
		}

		private void OnAbout(object sender, System.EventArgs e)
		{
			System.Reflection.Assembly assembly = System.Reflection.Assembly.GetAssembly(
				typeof(MindFusion.Scheduling.WinForms.Calendar));

			if (assembly == null)
				return;

			Type aboutFormType = assembly.GetType(
				"MindFusion.Scheduling.WinForms.AboutForm");

			if (aboutFormType == null)
				return;

			((Form)Activator.CreateInstance(aboutFormType)).ShowDialog(this);
		}

		private void OnExit(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void calendar_Draw(object sender, MindFusion.Scheduling.WinForms.DrawEventArgs e)
		{
			if (e.Element == CustomDrawElements.ResourceViewCellComplete)
			{
				Rectangle bounds = e.Bounds;
				bounds.X += 1;
				bounds.Width -= 1;

				RectangleF fbounds = new RectangleF(
					bounds.X, bounds.Y, bounds.Width, bounds.Height);

				StringFormat f = new StringFormat();
				f.Alignment = StringAlignment.Center;
				f.LineAlignment = StringAlignment.Center;

				if (e.Resource != null)
				{
					if (e.Date.Date == new DateTime(2006, 3, 27))
					{
						if (e.Resource.Id == "IdRamon")
						{
							e.Graphics.FillRectangle(_brush1, bounds);
							e.Graphics.DrawString("Office", _font, _textBrush, fbounds, f);
						}
					}

					if (e.Date.Date == new DateTime(2006, 3, 28))
					{
						if (e.Resource.Id == "IdGreg" ||
							e.Resource.Id == "IdTom" ||
							e.Resource.Id == "IdMando" ||
							e.Resource.Id == "IdAlfredo" ||
							e.Resource.Id == "IdJJ" ||
							e.Resource.Id == "IdLuis" ||
							e.Resource.Id == "IdScott" ||
							e.Resource.Id == "IdRamon")
						{
							e.Graphics.FillRectangle(_brush1, bounds);
							e.Graphics.DrawString("Office", _font, _textBrush, fbounds, f);
						}

						if (e.Resource.Id == "IdChuck")
						{
							e.Graphics.FillRectangle(_brush2, bounds);
							e.Graphics.DrawString("Research", _font, _textBrush, fbounds, f);
						}
					}

					if (e.Date.Date == new DateTime(2006, 3, 29))
					{
						if (e.Resource.Id == "IdMike" ||
							e.Resource.Id == "IdAlfredo" ||
							e.Resource.Id == "IdLuis" ||
							e.Resource.Id == "IdRamon")
						{
							e.Graphics.FillRectangle(_brush1, bounds);
							e.Graphics.DrawString("Office", _font, _textBrush, fbounds, f);
						}
					}

					if (e.Date.Date == new DateTime(2006, 3, 30))
					{
						if (e.Resource.Id == "IdMike" ||
							e.Resource.Id == "IdGreg" ||
							e.Resource.Id == "IdTom" ||
							e.Resource.Id == "IdAlfredo" ||
							e.Resource.Id == "IdLuis" ||
							e.Resource.Id == "IdScott" ||
							e.Resource.Id == "IdRamon")
						{
							e.Graphics.FillRectangle(_brush1, bounds);
							e.Graphics.DrawString("Office", _font, _textBrush, fbounds, f);
						}
					}

					if (e.Date.Date == new DateTime(2006, 3, 31))
					{
						e.Graphics.FillRectangle(_brush1, bounds);
						e.Graphics.DrawString("Office", _font, _textBrush, fbounds, f);
					}
				}
			}

			else if (e.Element == CustomDrawElements.ResourceViewRowHeader)
			{
				e.Graphics.DrawLine(Pens.White,
					e.Bounds.Right - 1,
					e.Bounds.Top,
					e.Bounds.Right - 1,
					e.Bounds.Bottom - 2);
			}
		}


		private string _appPath;
		private Brush _brush1 = new SolidBrush(Color.FromArgb(254, 249, 207));
		private Brush _brush2 = new SolidBrush(Color.FromArgb(254, 192, 203));
		private Font _font = new Font("Verdana", 7.5f, FontStyle.Underline);
		private Brush _textBrush = new SolidBrush(Color.FromArgb(22, 88, 92));
	}
}
